<div class="ptransform-help">
    <div class="help">
        <h2 class="form-header">Basic Usage</h2>
        <p>The simplest way to use Parallaxia is by having it modify a parameter of a tile with constant rate over time.
       For example shift the position of a tiling texture every frame, animating moving ground or drifting clouds.

        This can be done in the main view of the Parallaxia Configuration window where the basic parameters are listed.
        </p>
        <p>The left column defines the initial state when the scene is loaded, the right side displays the current state.
        </p>
        <ul>
            <li>Position on the map</li>
            <li>Position change over time (Note, tiles would just drift away when reaching the edge)</li>
            <li>Width/height of the tile. Dragging the handles is currently borked.</li>
            <li>Rotation in radians</li>
            <li>Tile color tinting</li>
            <li>Alpha/transparency of the tile (capped to a minimum of 0.2 for the GM).</li>
        </ul>
        Specific to the tiling nature of the Parallaxia Tiles:
        <ul>
            <li>Scale of the texture, stretching or compressing it over the tile</li>
            <li>Change of scale over time</li>
            <li>Tile texture offset on start.</li>
            <li>Tile offset change. This is the <b>most useful to get started</b>. Setting this to non-zero will move the texture on the tile over time.</li>
        </ul>

<!--        Custom function-->
        <h2 class="form-header">Custom Function</h2>
        <p>Each frame, a new State is calculated, representing above listed parameters. Each frame this custom function can modify the State and the tile will be
        rendered with the new parameters. The custom function acts just like a script macro, but four variables are of note: </p>
        <ul>
            <li><var>t: </var> Unix timestamp</li>
            <li><var>delta: </var> Time since last frame in milliseconds</li>
            <li><var>previous: </var> State of tile in previous frame</li>
            <li><var>current: </var> State of tile current frame</li>
            <li><var>next: </var> State of tile in next frame</li>
        </ul>
        <p>Each frame update, the <var>next</var> State is calculated based on the current frame, e.g. applying static time variant effects listed in the "Basic Usage" Section above.
        After that the custom function is called and can overwrite the calculated State parameters. For example to have a tile fly in a circle while always pointing the same direction:
        </p>
        <textarea disabled="disabled" rows="7">let x0 = initial.position.x;
let y0 = initial.position.y;
let dx = Math.sin(t/1000/2) * 1000;
let dy = Math.cos(t/1000/2) * 1000;
next.rotation.z = Math.atan2(dy, dx);
next.position.x = x0 + dx;
next.position.y = y0 + dy;</textarea>
<!--        <pre><code>-->
<!--</code></pre>-->

        <p>To get an idea how the State object is structured, take a look at the
            <var><a onclick="console.log(CONFIG.ParallaxiaTile.defaultState)">CONFIG.ParallaxiaTile.defaultState</a></var> variable.
        </p>


    </div>
</div>